#include "../src/zeusmp.def"
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     j.c. vernaleo 11/24/03
c     based on hsplice
c     allows for hsplice to loop over multiple files
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       subroutine hsp2

       implicit NONE
#ifdef HDF_DUMPS
#include "../src/param.h"
#undef MPI_USED
#include "../src/mpicom.h"
#include "../src/grid.h"
#include "../src/root.h"
c
      integer  irestart
c
c  Removed redundant i,j,k which cause warning or fail
c  2/04/04 jcv
      integer  nbl,igrid,imin,imax,jmin,jmax,kmin,kmax
      logical  lgrid
c     
      integer iskip,jskip,kskip,izone,jzone,kzone
      integer n, indx, icmb, ndump
      integer startd,stopd
      integer it,jt,kt,i,j,k,itil
      integer nfunc,lfunc,ret,shape(3),rank,rcmb,shcmb(3)
      real     xscale(in),yscale(jn),zscale(kn)
      integer  max_pe,max_fc
      parameter(max_pe=128,max_fc=129)
      real     xscmb(max_pe*in),yscmb(max_pe*jn),zscmb(max_pe*kn)
      real     data(in*jn*kn),dcmb(max_pe*in*jn*kn)
      REAL     x1min,x1max,x1rat,dx1min,dfndx1r,x1r,deltx1r,errx1r
     &     ,x2min,x2max,x2rat,dx2min,dfndx2r,x2r,deltx2r,errx2r
     &     ,x3min,x3max,x3rat,dx3min,dfndx3r,x3r,deltx3r,errx3r
      character*8 phrase
      character*15 hdf(max_pe), cmb
      character*120 line
      character strng(max_fc)*32,qunit*1,qfrmt*1,qcoord*16
c     
      integer  dsgdims,dsgdisc,dsgdata,dsgdast
      integer  dssdims,dssdast,dssdisc,dsadata,dspdata
      external dsgdims,dsgdisc,dsgdata,dsgdast
      external dssdims,dssdast,dssdisc,dsadata,dspdata
#ifdef SD
      integer*4 sd_id, sds_id, sd_index
      integer  sfstart, sfcreate, sfwdata, sfendacc, sfend
      integer  sfrdata, sfselect
      integer  start(3), stride(3)
      integer*4 DFACC_CREATE, DFNT_INT16, DFACC_READ
      integer*4 FAIL, DFNT_FLOAT32
      parameter (DFACC_CREATE = 4, DFNT_INT16 = 22, DFNT_FLOAT32 = 5,
     +     DFACC_READ = 1, FAIL = -1)
#endif /* SD */
CPS
      integer ntotal,inz,jnz,knz
      character*2 x2units,x3units
c
      namelist /rescon/ irestart,tdump,dtdump,id,resfile
      namelist /mpitop/ ntiles, periodic
      namelist /ggen1/  nbl,x1min,x1max,igrid,x1rat,dx1min,lgrid
      namelist /ggen2/  nbl,x2min,x2max,igrid,x2rat,dx2min,x2units,lgrid
      namelist /ggen3/  nbl,x3min,x3max,igrid,x3rat,dx3min,x3units,lgrid
c
c.......................................................................
c
c Read ZEUS-MP input file "zmp_inp" to determine the number of zones
c in each direction in the physical mesh (nx1z,nx2z,nx3z), and the 
c number of tiles in each direction "ntiles".
c
      open(1,file='zmp_inp',status='old')
c
c   Look for and read the "mpitop" and "ggen*" namelists.
c
c      do 10 n=1,100
c         read(1,"(a8)") phrase
c         if (phrase(3:8) .eq. 'mpitop') goto 20
c 10   continue
c      write(*,"(/'HSPLICE: ERROR -- Did not find mpitop namelist.')")
c      close (1)
c      return
c
 20   continue
c     backspace (1)
      read(1,mpitop)
      write(*,"('HSPLICE: ntiles is ',3i6)") ntiles(1),ntiles(2)
     &     , ntiles(3)
c
c   Read the "rescon" namelist to find the run's "id".
c
      irestart = 0
      tdump = 0.0
      dtdump = 0.0
      id     = 'aa'
      resfile= 'resaa000000.000'
      read (1,rescon)
      write(*,"(/'HSPLICE: id is ',a)") id
c
      imax  = 3
      imin = imax
      nbl   = 1
      lgrid = .false.
c     
 30   continue
      read(1,ggen1)
      imax = imax + nbl
      if (.not. lgrid) go to 30
c
      nx1z = ( imax - imin ) / ntiles(1)
CPS
#ifdef GRAV
      izone=imax-imin
#endif
C
c
      jmax  = 3
      jmin  = jmax
      nbl   = 1
      lgrid = .false.
c
 40   continue
      read(1,ggen2)
      jmax = jmax + nbl
      if (.not. lgrid) go to 40
c
      nx2z = ( jmax - jmin ) / ntiles(2)
CPS
#ifdef GRAV
      jzone=jmax-jmin
#endif
C
c
      kmax  = 3
      kmin = kmax
      nbl   = 1
      lgrid = .false.
c
 50   continue
      read(1,ggen3)
      kmax = kmax + nbl
      if (.not. lgrid) go to 40
c
      nx3z = ( kmax - kmin ) / ntiles(3)
CPS
#ifdef GRAV
      kzone=kmax-kmin
#endif
C
      write(*,"('HSPLICE: nx1z,nx2z,nx3z are ',3i6)") nx1z,nx2z,nx3z
      close(1)

ccccccccccccccccccccHere is where it differs from hsplice

      write(*,"(/'hsp2: Enter number of first dump'/)")
      read(*,*) startd
      write(*,"(/'hsp2: Enter number of last dump'/)")
      read(*,*) stopd

      do ndump=startd,stopd

c
c Generate names of hdf files to read.
c
         indx = 0
         do 90 kt=0,ntiles(3)-1
            do 80 jt=0,ntiles(2)-1
               do 70 it=0,ntiles(1)-1
                  indx = indx + 1
                  write(hdf(indx),"(a3,a2,3i2.2,'.',i3.3)") 'hdf',id
     &                 , it,jt,kt,ndump
 70            continue
 80         continue
 90      continue
         nprocs = indx
c.......................................................................
c
c Read each function from each tile's dump and write it into
c the combined file 'cmb' ("hdf<id>.<ndump>").
c
         write(*,"(a11,a2,'.',i3.3)") 'Writing hdf',id,ndump
         write(cmb,"(a3,a2,'.',i3.3)") 'hdf',id,ndump
c
c   Loop over the number of functions to be read -- determine number.
c
         nfunc = 5
#ifdef MHD
      nfunc = nfunc + 3
#endif /* MHD */
#if defined RAD || defined RAD_EXP
      nfunc = nfunc + 1
#endif /* RAD || RAD_EXP */
      do lfunc=1,nfunc
c
c   For each tile, read one function.  On the first pass, read
c   and save the mesh points for each tile.
c
CPS
         indx = 0
         inz=0
         jnz=0
         knz=0
#ifdef GRAV
      kskip = 0
#endif
         do kt=0,ntiles(3)-1
#ifdef GRAV
           jskip = 0
#endif
           do jt=0,ntiles(2)-1
#ifdef GRAV
             iskip = 0
#endif
             do it=0,ntiles(1)-1
               indx = indx + 1
#ifdef SD
               sd_id = sfstart(hdf(indx), DFACC_READ)
#endif /* SD */
#ifndef GRAV
               if (lfunc.eq.1) then
#endif
C
#ifndef SD
                 ret = dsgdims(hdf(indx),rank,shape,3)
                 ret = dsgdisc(1,shape(1),xscale)
                 ret = dsgdisc(2,shape(2),yscale)
                 ret = dsgdisc(3,shape(3),zscale)
#else
                 start(1) = 0
                 start(2) = 0
                 start(3) = 0
c
                 stride(1) = 1
                 stride(2) = 1
                 stride(3) = 1
c
                 sd_index = 0
                 sds_id = sfselect (sd_id, sd_index)
                 ret = sfrdata(sds_id,0,1,3,shape)
                 ret = sfendacc(sds_id)
c
                 sd_index = 1
                 sds_id = sfselect (sd_id, sd_index)
                 ret = sfrdata(sds_id,0,1,shape(1),xscale)
                 ret = sfendacc(sds_id)
c
                 sd_index = 2
                 sds_id = sfselect (sd_id, sd_index)
                 ret = sfrdata(sds_id,0,1,shape(2),yscale)
                 ret = sfendacc(sds_id)
c
                 sd_index = 3
                 sds_id = sfselect (sd_id, sd_index)
                 ret = sfrdata(sds_id,0,1,shape(3),zscale)
                 ret = sfendacc(sds_id)
#endif
c
c         Copy the mesh points for the tile into the cmb mesh arrays.
c
CPS
#ifdef GRAV
                 nx1z=shape(1)
                 nx2z=shape(2)
                 nx3z=shape(3)

                 do i=1,nx1z
                   xscmb(i+iskip) = xscale(i)
                 enddo ! i
                 do j=1,nx2z
                   yscmb(j+jskip) = yscale(j)
                 enddo ! j
                 do k=1,nx3z
                   zscmb(k+kskip) = zscale(k)
                 enddo ! k
#endif
#ifndef GRAV
                 do i=1,nx1z
                   xscmb(i+it*nx1z) = xscale(i)
                 enddo ! i
                 do j=1,nx2z
                   yscmb(j+jt*nx2z) = yscale(j)
                 enddo ! j
                 do k=1,nx3z
                   zscmb(k+kt*nx3z) = zscale(k)
                 enddo ! k
               endif ! lfunc = 1
#endif
C
c
c         Read the tile HDF file for the lfunc-th function.
c
#ifndef SD
               do n=1,lfunc
                 ret = dsgdata(hdf(indx),rank,shape,data)
                 ret = dsgdast(strng(lfunc),qunit,qfrmt,qcoord)
               enddo ! n
#else
               sd_index = lfunc-1 + 4
               sds_id = sfselect (sd_id, sd_index)
               ret = sfrdata(sds_id,start,stride,shape,data)
               ret = sfendacc(sds_id)
#endif
c
c         Copy data values for this tile into the cmb data array.
c
               do k=1,nx3z
                 do j=1,nx2z
                   do i=1,nx1z
                     itil       = i + (j-1)*nx1z + (k-1)*nx1z*nx2z
CPS
#ifdef GRAV
                     icmb       = i + iskip 
     1                          + (j+jskip-1)*izone
     2                          + (k+kskip-1)*izone*jzone
#endif
#ifndef GRAV
                     icmb       = i + it*nx1z 
     1                          + (j+jt*nx2z-1)*(ntiles(1)*nx1z)
     2                          + (k+kt*nx3z-1)*(ntiles(1)*nx1z)
     3                          * (ntiles(2)*nx2z)
#endif
C
                     dcmb(icmb) = data(itil)
                   enddo ! i
                 enddo ! j
               enddo ! k
c
#ifdef SD
               ret = sfend(sd_id)
#endif
CPS
#ifdef GRAV
               iskip = iskip + shape(1)
               if(jt.EQ.0 .AND.kt.EQ.0) inz=inz+shape(1)
#endif
             enddo ! it
#ifdef GRAV
             jskip = jskip + shape(2)
             if(kt.EQ.0) jnz=jnz+shape(2)
#endif
           enddo ! jt
#ifdef GRAV
           kskip = kskip + shape(3)
           knz=knz+shape(3)
#endif
         enddo ! kt
C
c
c   For the first function only, name the cmb mesh HDF file and
c   prepare it to receive data (after reading all tiles mesh points).
c
         rcmb     = 3
CPS
#ifdef GRAV
         shcmb(1) = izone
         shcmb(2) = jzone
         shcmb(3) = kzone
#endif
#ifndef GRAV
         shcmb(1) = nx1z*ntiles(1)
         shcmb(2) = nx2z*ntiles(2)
         shcmb(3) = nx3z*ntiles(3)
#endif
C
         ret = dssdims(rcmb,shcmb)
         ret = dssdisc(1,shcmb(1),xscmb)
         ret = dssdisc(2,shcmb(2),yscmb)
         ret = dssdisc(3,shcmb(3),zscmb)
#ifndef SD
         ret = dssdast(strng(lfunc),' ',' ',qcoord)
#endif
         if (lfunc.eq.1) then
c
c   Write the cmb mesh data into the combined file for this function.
c
           ret = dspdata(cmb,rcmb,shcmb,dcmb)
         else ! lfunc = 1
c
c   Append the cmb mesh data into the combined file for this function.
c
           ret = dsadata(cmb,rcmb,shcmb,dcmb)
         endif ! lfunc = 1
       enddo ! lfunc

       enddo
       return





ccccccccccccccccccccccccccccccccccccccccccccccccc
c.......................................................................
c
c Error messages
c
  999  continue
       write(*,"(/'HSPLICE: ERROR -- could not open file ',a15
     & , ' for tile ',i4)") hdf(indx),indx
c
#endif /* HDF_DUMPS */
       return
       end
