#include "../src/zeusmp.def"
c-----------------------------------------------------------------------
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
       program zmp_pp
c
c ZEUS-MP Post-processor: Main Program.
c
c PURPOSE:  This program asks the user what post-processing taskes
c           to perform, and calls the appropriate routines.
c
c LAST MODIFIED: RAF, 9/12/96.
c
c.......................................................................
c
       implicit NONE
#include "../src/param.h"
       integer i, ltask
       character task*8
       external splice, diff
c.......................................................................
c
c Write greeting.
c
       write(*,"(/'ZMP_PP: Welcome to the ZEUS-MP Post-Processor!')")
       ltask = len( task )
c
c Loop back here for next task.
c
   10  continue
c
c Determine task.
c
       do 20 i=1,ltask
         task(i:i) = ' '
   20  continue
       write(*,"(/'ZMP_PP: What task would you like performed?')")
       write(*,"('ZMP_PP: Choose from:  splice, hsplice, diff, quit'/)")
       read(*,"(a)") task
c
c QUIT
c
       if (task(1:4) .eq. 'quit') then
         stop
       else if (task(1:6) .eq. 'splice') then
c
c SPLICE USERDUMPs -- textfiles "usr<id><coords>.<ndump>"
c
         call splice
         goto 10
       else if (task(1:7) .eq. 'hsplice') then
c
c SPLICE HDFDUMPs -- HDF Scientific Data Sets "hdf<id><coords>.<ndump>"
c
         call hsp2
         goto 10
       else if (task(1:4) .eq. 'diff') then
c
c DIFF -- Produce a file whose entries are the difference
c         between the entries in two input files.
c
         call diff
         goto 10
       else
c
c WHAT?
c
         write(*,"(/'ZMP_PP: Please retype your task.')")
         goto 10
       endif
c
       end
