#include "zeusmp.def"

C CSR - 5/15/03 (based on AJY - 12/11/02)

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////              B U B B L E                  \\\\\\\\\\
c
c
c=======================================================================
c
       subroutine bubble

       implicit NONE
#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#include "mpicom.h"

       integer i,j,k

       REAL r0,rho0,cs
       REAL r_bub,r_bubcen,rho_bub,overpress
       REAL k_off,ktemp
       REAL rad

#ifdef PHYS_VISC
       REAL total_diss
       common/dissipation/total_diss
#endif /* PHYS_VISC */

c removed unused bndyall
       external      bndyflgs

       r0=1.0
       rho0=1.0
       cs=1.0
       r_bub=0.25
       r_bubcen=0.25
       rho_bub=0.01
c       rho_bub=0.1
       overpress=2.0
#ifdef PHYS_VISC
       total_diss=0.0
#endif /* PHYS_VISC */

       k_off=0.5

c       write (iotty, 2011)
c       write (iolog, 2011)
c2011   format('MYPROB  : Initialisation commencing')
       write(6,"(10x,'MYPROB  : Initialisation commencing')")
c
c
      do k=ks-2,ke+2
         do j=js-2,je+2
            do i=is-2,ie+2
c
c     set up undisturbed atmosphere
c
c               rad=sqrt(x1b(i)**2.0+x2b(j)**2.0+x3b(k)**2.0)
c               d(i,j,k)=rho0/((1.0+(rad/r0)**2.0)**0.75)
c     Plane parallel version
               d(i,j,k)=rho0/((1.0+(x3b(k)/r0)**2.0)**0.75)

               e(i,j,k)=d(i,j,k)*cs**2.0/(gamma*(gamma-1.0))
               v1(i,j,k)=0.0
               v2(i,j,k)=0.0
               v3(i,j,k)=0.0
#ifdef GRAV
               gp(i,j,k)=cs**2.0*log(d(i,j,k))/gamma
#endif /* GRAV */
c
c     set up bubble
c
               ktemp=x3b(k)-k_off
               rad=x1b(i)**2.0+x2b(j)**2.0+
     1            (ktemp-r_bubcen)**2.0
               rad=sqrt(rad)
               if (rad .lt. r_bub) then
c                  write(*,*)x3b(k),'at k= ',k
                  d(i,j,k)=rho_bub
                  e(i,j,k)=e(i,j,k)*overpress
               endif
            enddo
         enddo
      enddo

       call bndyflgs


c---All done

c       write (iotty, 2010)
c       write (iolog, 2010)
c2010   format('MYPROB  : Initialisation complete.')
c

       return
       end
