/*
  clocks.h contains declaration statements for variables used to obtain
  the CPU and wall clock times on various systems.  The precision and
  routine names are the main issues.  
  
  Requires zeusmp.def, param.h, mod_names.h.
  
  Written by RAF; last modified 3/25/96.
*/

#if defined UNICOS || defined CONVEXOS || defined EXEMPLAR
/*
  These systems have timing routines that are better than the UNIX
  standard etime/itime.
*/
#ifdef UNICOS
      REAL      second, tarray, cputime0, cputime
     &        , wclock0, wclock
      external  second
#ifndef MPI_USED
      integer   iarray
      REAL      timef
      external  timef
#endif
#endif

#ifdef CONVEXOS
      real*4    zero4, cputime, cputime0, cputime, tarray
     &        , wclock0, wclock
      external  cputime
#ifndef MPI_USED
      integer   iarray
      real*4    secnds
      external  secnds
#endif
#endif

#ifdef EXEMPLAR
      integer   descript                    ! (Timer descriptor)
      real*4    zero4, tarray(2), cputime0, cputime 
     &        , wclock0, wclock
      external  ttimer
      common    /checki/ iarray, descript
      integer   iarray(3)
      real*4    walltime_
      external  walltime_
#endif /* EXEMPLAR */

#else /* defined UNICOS || defined CONVEXOS || defined EXEMPLAR */

#ifdef NO_CPU_TIMER
      real*4    tarray(2), cputime0, cputime
     &        , wclock0, wclock
#else
      real*4    tarray(2), ETIME, cputime0, cputime
     &        , wclock0, wclock
      external  ETIME
#endif /* NO_CPU_TIMER */

#ifndef MPI_USED
      integer   iarray(3), ITIME
      external  ITIME
#endif /* MPI_USED */

#endif /* defined UNICOS || defined CONVEXOS || defined EXEMPLAR */

      common    /checkr/ tarray, cputime0, wclock0
#ifndef MPI_USED
#ifndef EXEMPLAR
      common    /checki/ iarray
#endif /* not EXEMPLAR */
#endif /* MPI_USED */

#ifdef PROFILING
#ifdef MPE_USED
#else
       REAL
     &    cpu0, cpu1, wal0, wal1
     & ,  timers ( nsubstps, 4, 2, 2 )
c                    .      .  .  .
c                   .      .    .  .
c                  .      .      .  .
c                 .      .       .   .
c                .      .        .    .
c               .      .         .     .
c          substeps  i,j,k,r  comm/work cpu/wall
c
c  SUBSTEPS
c  1) Forces
c  2) Artificial Viscosity
c  3) PdV
c  4) tranx1
c  5) momx1
c  6) tranx2
c  7) momx2
c  8) tranx3
c  9) momx3
c 10) BCs
c
       common /timing/
     &    cpu0, cpu1, wal0, wal1
     & ,  timers
#endif /* MPE_USED */
#endif /* PROFILING */
