#include "zeusmp.def"
c=======================================================================
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
      subroutine dataio(iswres,iswhdf,iswtsl,iswhst,iswusr
#ifdef SHELLS
     .                 ,iswshl
#endif /* SHELLS */
     .                                             )
c
c  PURPOSE:  Controls data I/O for restart, HDF, history, and USER
c  dumps.  The latter is an arbitrary routine the user can add for
c  problem dependent i/o included using the cpp macroname USERDUMP
c  Added control for tslice.
c
c  INPUT ARGUMENTS: iswres,iswhdf,iswhst=switches for restart,hdf, and
c    history dumps.  Values of 1 ensure dumps will be made.
c
c  OUTPUT ARGUMENTS: none
c
c  EXTERNALS: MSAVE, HDFALL, STRTOI, HDUMP, USERDUMP, TSLICE
c
c  LOCALS:
c
c  LAST MODIFIED:  by John Hayes; 9/9/97
c  LAST MODIFIED:  by efh 04/15/99 including call to tslice
c-----------------------------------------------------------------------
      implicit NONE
#include "param.h"
#include "root.h"
#include "mpicom.h"
c-----------------------------------------------------------------------
      integer iswres,iswhdf,iswhst,iswusr,iswshl,iswtsl
#ifdef SHELLS
     .       ,iswshl
#endif /* SHELLS */
      integer incr,strtoi
      REAL t_out(nbuff-8)
      common / op_times / t_out
c switched to new restart routines 7/08/04 jcv
      external msave2, hdfall, strtoi, printd, USERDUMP, tslice
c
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\/////////////////////////////////
c=======================================================================
c
cFH   if (dtdump .gt. 0.0 .and. tused .ge. (tdump+dtdump)) then
      if (dtdump .gt. 0.0 .and. time .ge. (tdump+dtdump)) then
        tdump = tdump + dtdump
        iswres = 1
      endif
      if (dthdf  .gt. 0.0 .and. time  .ge. (thdf+dthdf)) then
        thdf = thdf + dthdf
        iswhdf = 1
      endif
      if (dttsl  .gt. 0.0 .and. time  .ge. (ttsl+dttsl)) then
        ttsl = ttsl + dttsl
        iswtsl = 1
      endif
      if (dthist .gt. 0.0 .and. time  .ge. (thist+dthist)) then
        thist = thist + dthist
        iswhst = 1
      endif
      if (dtusr .gt. 0.0 .and. time  .ge. (tusr+dtusr)) then
        tusr = tusr + dtusr
        iswusr = 1
      endif
#ifdef SHELLS
      if (dtshl .gt. 0.0 .and. time  .ge. (tshl+dtshl)) then
        tshl = tshl + dtshl
        iswshl = 1
      endif
#endif /* SHELLS */
c
c  restart dump
c
#ifdef RES_DUMPS
      if (iswres .eq. 1) then
c switched to new restart routines 7/08/04 jcv
        call msave2(resfile)
        incr = strtoi(resfile,13,15) + 1
c make it use alernating restart dumps instead of a new one every time
c jcv 7/19/04
        if(incr.ge.2)then
           incr=0
        endif
        write(resfile,"(a3,a2,3i2.2,'.',i3.3)") 'res',id,coords(1)
     &                                      ,coords(2),coords(3),incr
        iswres=0
      endif
#endif /* RES_DUMPS */
c
c  HDF dump
c
#ifdef HDF_DUMPS
      if (iswhdf .eq. 1) then
        call hdfall(hdffile)
        incr = strtoi(hdffile,13,15) + 1
        write(hdffile,"(a3,a2,3i2.2,'.',i3.3)") 'hdf',id,coords(1)
     &                                      ,coords(2),coords(3),incr
c
c If an array of output times t_out has been defined, set the value
c of (thdf + dthdf) to the next desired output time.
c
        if (incr .le. nbuff-8) then
          if (t_out(incr).ne.0.0) then
            thdf = t_out(incr) - dthdf
          endif
        endif
        iswhdf=0
      endif
#endif /* HDF_DUMPS */
c
c  tslice dump
c
#ifdef TSL_DUMPS
      if (iswtsl .eq. 1) then
        call tslice
        iswtsl=0
      endif
#endif /* TSL_DUMPS */
c
c  history dump
c
#ifdef HST_DUMPS
      if (iswhst .eq. 1) then
        call printd
        iswhst=0
      endif
#endif /* HST_DUMPS */
#ifdef SHELLS
c
c   shells output
c
      if (iswshl .eq. 1) then
        call shelldmp
        iswshl=0
      endif
#endif /* SHELLS */
c
c  USER dump
c
#ifdef TXT_DUMPS
      if (iswusr .eq. 1) then
        call USERDUMP
        incr = strtoi(usrfile,13,15) + 1
        write(usrfile,"(a3,a2,3i2.2,'.',i3.3)") 'usr',id,coords(1)
     &                                      ,coords(2),coords(3),incr
c
c If an array of output times t_out has been defined, set the value
c of (tusr + dtusr) to the next desired output time.
c
        if (incr .le. nbuff-8) then
          if (t_out(incr).ne.0.0) then
            tusr = t_out(incr) - dtusr
          endif
        endif
        iswusr=0
      endif
#endif /* TXT_DUMPS */
c
      return
      end
