#include "zeusmp.def"

c JCV 11/18/03  subroutines to help print out debugging info

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                  before                   \\\\\\\\\\
c
c=======================================================================
c
ccc
c To make this output to a file put in main loop of main program
c after the variable declarations
c     open(unit=5,file="debug.dat")
cccc
c And after main loop put
c     close(5)
ccccccc
c
c Then replace all write(*,*) with write(5,*)


       subroutine before(array,varname,stpname)

       implicit NONE

#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#if defined RAD || defined RAD_EXP
#include "radiation.h"
#include "opac.h"
#include "radexp.h"
#include "cons.h"
#endif /* RAD || RAD_EXP */
#include "mpicom.h"

       REAL array(in,jn,kn)
       REAL testmax,testmin
       integer scrapi,scrapj,scrapk
       character*7 varname,stpname


        if(myid .EQ. 0) then
        testmax=0.0
        testmin=0.0
        do scrapi=is-2,ie+2
           do scrapj=js-2,je+2
              do scrapk=ks-2,ke+2
                 testmax=max(testmax,array(scrapi,scrapj,scrapk))
                 testmin=min(testmin,array(scrapi,scrapj,scrapk))
              enddo
           enddo
        enddo
        if((testmax .NE. 0.0) .AND. (testmin .NE. 0.0))then
           write(*,*) 'Time= ',time,' dt= ',dt
           write(*,*) 'max of ',varname,' before ',stpname,' = ',testmax
           write(*,*) 'min of ',varname,' before ',stpname,' = ',testmin
        endif
        endif

        end



c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                  after                   \\\\\\\\\\
c
c=======================================================================
c

       subroutine after(array,varname,stpname)

       implicit NONE

#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#if defined RAD || defined RAD_EXP
#include "radiation.h"
#include "opac.h"
#include "radexp.h"
#include "cons.h"
#endif /* RAD || RAD_EXP */
#include "mpicom.h"

       REAL array(in,jn,kn)
       REAL testmax,testmin
       integer scrapi,scrapj,scrapk
       character*7 varname,stpname

        if(myid .EQ. 0) then
        testmax=0.0
        testmin=0.0
        do scrapi=is-2,ie+2
           do scrapj=js-2,je+2
              do scrapk=ks-2,ke+2
                 testmax=max(testmax,array(scrapi,scrapj,scrapk))
                 testmin=min(testmin,array(scrapi,scrapj,scrapk))
              enddo
           enddo
        enddo
        if((testmax .NE. 0.0) .AND. (testmin .NE. 0.0))then
c           write(*,*) 'Time= ',time,' dt= ',dt
           write(*,*) 'max of ',varname,' after ',stpname,' = ',testmax
           write(*,*) 'min of ',varname,' after ',stpname,' = ',testmin
        endif
        endif

        end
