#include "zeusmp.def"
c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////            F G R E E N                    \\\\\\\\\\
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
c=======================================================================
c
c
      subroutine fgreen

#if alias GRAVITY.eq.fftgrav

c Compute the Green's function for fftgrav.  AB/M-MML 19.6.97

      REAL pi2, pi2n1, pi2n2, pi2n3, pi2g

      REAL green(0:in-1,0:jn-1,0:kn-1)

      integer i, j, k, n1, n2, n3

      common /greendat/ green

c--------------------------------------------------------

#ifdef DBGZEUS_FGREEN
      print*,'  fgreen : called'
#endif /* DBGZEUS_FGREEN */

c     set up constants

      n1 = ie - is + 1
      n2 = je - js + 1
      n3 = ke - ks + 1


      pi2=8.*atan(1.)
      pi2n1=8.*atan(1.)/n1
      pi2n2=8.*atan(1.)/n2
      pi2n3=8.*atan(1.)/n3
      pi2g=pi2*g*dx1a(is)*dx1a(is)

c$doacross   local   ( k, j, i),
c$&          share   ( green, n3, n2, n1, gp, 
c$&                    pi2n1, pi2n2 , pi2n3, pi2g, pi2 )

      do k=0,n3-1
        do j=0,n2-1
          do i=0,n1-1
            if (i.eq.0.and.j.eq.0.and.k.eq.0) then
              green(i,j,k)=1.
            else
              green(i,j,k)=pi2g/(cos(pi2n1*i)+
     &        cos(pi2n2*j)+cos(pi2n3*k)-3.)
            endif
          enddo
        enddo
      enddo

#ifdef DBGZEUS_FGREEN
      print*,'  fgreen : finished'
endif /* DBGZEUS_FGREEN */

#endif GRAVITY.eq.fftgrav
      return
      end


c=======================================================================
c
c    \\\\\\\\\\        E N D   S U B R O U T I N E        //////////
c    //////////              F G R E E N                  \\\\\\\\\\
c
c=======================================================================
