#include "zeusmp.def"
c=======================================================================
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
      subroutine gravity
c
c  Modified 1: by PSLi, 12/30/99, adding new Poisson dolver using FFTW.
c
#ifdef GRAV
      implicit NONE
#include "param.h"
#include "field.h"
#include "grid.h"
#include "gravity.h"
#include "mgmpi.h"
#include "mpicom.h"
#include "bndry.h"
      
      INTEGER N1LIM,N2LIM,N3LIM,NWLIM
      PARAMETER (N1LIM = I_ZONES+2)
      PARAMETER (N2LIM = J_ZONES+2)
      PARAMETER (N3LIM = K_ZONES+2)
      PARAMETER (NWLIM = 8*1.2*N1LIM*N2LIM*N3LIM)

      DOUBLE PRECISION xp(N1LIM),yp(N2LIM),zp(N3LIM)
      INTEGER icoords,numItFine,iStat
      DOUBLE PRECISION resFine,resRedFine,time
      INTEGER ixmb,ixpb,iymb,iypb,izmb,izpb
     
      INTEGER ifng,igtx,igty,igtz
      INTEGER nbr(6)
      DOUBLE PRECISION Z(NWLIM)

      integer i,j,k,l,lp
      integer id
      integer itemp,jtemp,ktemp
      DOUBLE PRECISION pig4,temp(ie*je*ke),temp1(ie,je,ke*4)
      integer inx,iny,inz,snz,n,ninz,status(MPI_STATUS_SIZE)

C     ----------------------------
C     *** Boundary value types ***
C     ----------------------------

C     (MGMPI: 1 = Dirichlet , 2 = Neumann , 3 = Periodic)

      IF(ntiles(1) .EQ. 1 .AND. ntiles(2) .EQ. 1 .AND. ntiles(3)
     &   .EQ. 1) THEN  
         IF (niis(3).LT.3) THEN
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
         IF (nois(3).LT.3) THEN 
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
         IF (nijs(3).LT.3) THEN
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
         IF (nojs(3).LT.3) THEN
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
         IF (niks(3).LT.3) THEN
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
         IF (noks(3).LT.3) THEN
             PRINT*, 'Only Dirichlet and periodic b.c.''s are'
             PRINT*, 'currently supported in gravity.F'
         END IF
      ENDIF

      IF (niis(3).EQ.1) ixmb = MM_NEUMANN 
      IF (nois(3).EQ.1) ixpb = MM_NEUMANN
      IF (nijs(3).EQ.1) iymb = MM_NEUMANN
      IF (nojs(3).EQ.1) iypb = MM_NEUMANN 
      IF (niks(3).EQ.1) izmb = MM_NEUMANN 
      IF (noks(3).EQ.1) izpb = MM_NEUMANN

      IF (niis(3).EQ.3) ixmb = MM_DIRICHLET 
      IF (nois(3).EQ.3) ixpb = MM_DIRICHLET 
      IF (nijs(3).EQ.3) iymb = MM_DIRICHLET 
      IF (nojs(3).EQ.3) iypb = MM_DIRICHLET 
      IF (niks(3).EQ.3) izmb = MM_DIRICHLET 
      IF (noks(3).EQ.3) izpb = MM_DIRICHLET 

      IF (niis(3).EQ.4) ixmb = MM_PERIODIC
      IF (nois(3).EQ.4) ixpb = MM_PERIODIC
      IF (nijs(3).EQ.4) iymb = MM_PERIODIC
      IF (nojs(3).EQ.4) iypb = MM_PERIODIC
      IF (niks(3).EQ.4) izmb = MM_PERIODIC
      IF (noks(3).EQ.4) izpb = MM_PERIODIC

C     --------------
C     *** Domain ***
C     --------------

      nbr(1) = n1m
      nbr(2) = n2m
      nbr(3) = n3m
      nbr(4) = n1p
      nbr(5) = n2p
      nbr(6) = n3p

C     --------------
C     *** Domain ***
C     --------------


*       if(coords(1) .eq. 0 .and. coords(2) .eq. 0 .and. coords(3)
*      .             .eq. 0) then
*         buf_in(1) = x1b(is-1)
*         buf_in(2) = x2b(js-1)
*         buf_in(3) = x3b(ks-1)
*         call MPI_BCAST(buf_in,3,MPI_FLOAT,myid,comm3d,ierr)
*       endif
*       xg1 = buf_in(1)
*       yg1 = buf_in(2)
*       zg1 = buf_in(3)
* 
*       if(coords(1) .eq. ntiles(1)-1 .and. 
*      .   coords(2) .eq. ntiles(2)-1 .and.
*      .   coords(3) .eq. ntiles(3)-1) then
*         buf_in(1) = x1b(ie+1)
*         buf_in(2) = x2b(je+1)
*         buf_in(3) = x3b(ke+1)
*         call MPI_BCAST(buf_in,3,MPI_FLOAT,myid,comm3d,ierr)
*       endif
*       xg2 = buf_in(1)
*       yg2 = buf_in(2)
*       zg2 = buf_in(3)

C     --------------------
C     Coordinate system
C     --------------------

#ifdef XYZ
      icoords = MM_CARTESIAN
#endif
#ifdef ZRP
      icoords = MM_CYLINDRICAL
#endif
#ifdef RTP
      icoords = MM_SPHERICAL
#endif

C     --------------
C     *** Problem ***
C     --------------

      ifng = -1

C     ----------------------
C     *** Discretization ***
C     ----------------------

      igtx = 1 ! spacing:       1 uniform, 2 nonuniform
      igty = 1
      igtz = 1
c
c Call James Bordner's MPI-based multigrid solver MGMPI.
c
#ifdef DEBUG
      write (*,"('GRAVITY: Calling mmMgSolve')") 
#endif
c===================================================
C       CALL mmMgSolve (
C      &     xg1,yg1,zg1,xg2,yg2,zg2,                 ! 
C      &     gp(is,js,ks),d(is,js,ks),icoords,        !
C      &     gpiib(js,ks,1),gpoib(js,ks,1),
C      &     gpijb(is,ks,1),gpojb(is,ks,1),
C      &     gpikb(is,js,1),gpokb(is,js,1),
C      &     ixmb,ixpb,iymb,iypb,izmb,izpb,           ! XXXXXX
C      &     in,jn,kn,                                ! 
C      &     nxg,nyg,nzg,                             ! 
C      &     dx1b(2),dx2b(2),dx3b(2),                 ! 
C      &     ntiles(1),ntiles(2),ntiles(3),           ! npx,npy,npz
C      &     coords(1),coords(2),coords(3),myid,      ! ipx,ipy,ipz,ip
C      &     nx1z+2,nx2z+2,nx3z+2,                    ! nx,ny,nz
C      &     comm3d,nbr,                              ! 
C      &     mi_fn_grv,mi_co_grv,                     ! maxit_mg,maxit_coarse
C      &     rt_fn_grv,rt_co_grv,                     ! rtol_mg,rtol_coarse
C      &     m_grv,wgt_grv,nu_pr_grv,nu_po_grv,       ! m,wgt,nu_pre,nu_post
C      &     vv_grv,                                  ! ivarvcycle
C      &     sl_fn_grv,sl_co_grv,smth_grv,            ! fine,coarse,smoother 
C      &     1,                                       ! amount of output
C      &     Z,NWLIM)                                 ! work storage and size
*      SUBROUTINE mmMgSolve (
*     &     xg1,yg1,zg1,xg2,yg2,zg2,
*     &     XI,FI,icoords,
*     &     XMB,XPB,YMB,YPB,ZMB,ZPB,
*     &     ixmb,ixpb,iymb,iypb,izmb,izpb,
*     &     xmbt,xpbt,ymbt,ypbt,zmbt,zpbt,
*     &     nxd2,nyd2,nzd2,
*     &     nxgi,nygi,nzgi,
*     &     hxi,hyi,hzi,
*     &     npx,npy,npz,ipx,ipy,ipz,ip,
*     &     nxi,nyi,nzi,
*     &     comm,nbr,
*     &     maxit_mg,maxit_coarse,
*     &     rtol_mg,rtol_coarse,
*     &     m,wgt,nu_pre,nu_post,ivarvcycle,
*     &     ifine_solver,icoarse_solver,iLineSmooth,
*     &     ioutput,
*     &     Z,nzl)

*  ( )  ifng
*  ( )  igtx
*  ( )  igty
*  ( )  igtz
*  ( )  xp
*  ( )  yp
*  ( )  zp
*  ( )  numitfine
*  ( )  resfine
*  ( )  resredfine
*  ( )  istat
*  ( )  time

      inx=ie-is+1
      iny=je-js+1
      inz=ke-ks+1
C
CPS Calculate boudary values of gravitation potential using multipole
C   expansion if Dirichlet BCs are specified.
C
      if(niis(3).NE.4.OR.nois(3).NE.4.OR.nijs(3).NE.4.OR.nojs(3).NE.4
     &   .OR.niks(3).NE.4.OR.noks(3).NE.4) call gpbv

      pig4=pi*g*4.D0

      do i=is,ie
         do j=js,je
            do k=ks,ke
               d(i,j,k)=d(i,j,k)*pig4
            enddo
         enddo
      enddo
C
CPS Adjust grid indexes for multigrid Poisson solver as only one 
C   ghost zone is required.
C
      is=is-1
      js=js-1
      ks=ks-1

      CALL mmInitMgmpi

      if(ixmb.EQ.3.OR.ixpb.EQ.3) then
         ixmb=3
         ixpb=3
      endif
      if(iymb.EQ.3.OR.iypb.EQ.3) then
         iymb=3
         iypb=3
      endif
      if(izmb.EQ.3.OR.izpb.EQ.3) then
         izmb=3
         izpb=3
      endif

      CALL mg3p (
* ---------------------
* Problem specification
     &     gp(is,js,ks),d(is,js,ks),ifng,icoords,        ! ifng	
     &     ixmb,ixpb,iymb,iypb,izmb,izpb,
     &     gpiib(js,ks,1),gpoib(js,ks,1),
     &     gpijb(is,ks,1),gpojb(is,ks,1),
     &     gpikb(is,js,1),gpokb(is,js,1),
     &     in,jn,kn,
* ---------------------
* Discretization
     &     igtx,igty,igtz,
     &     x1b(2),x2b(2),x3b(2),
     &     ntiles(1),ntiles(2),ntiles(3),
* ---------------------
* Concurrency
     &     coords(1),coords(2),coords(3),myid,      ! ipx,ipy,ipz,ip
     &     nx1z+2,nx2z+2,nx3z+2,                    ! nx,ny,nz
     &     comm3d,nbr,                              ! 
* ---------------------
* Solver
     &     mi_fn_grv,mi_co_grv,
     &     rt_fn_grv,rt_co_grv,
     &     m_grv,wgt_grv,nu_pr_grv,nu_po_grv,
     &     vv_grv,
     &     sl_fn_grv,sl_co_grv,smth_grv,
* ---------------------
* Output
     &     0,numItFine,resFine,resRedFine,istat,time, ! XOOOOO
* ---------------------
* Storage
     &     Z,NWLIM)                                 ! work storage and size
C
CPS Readjust the grid indexes after the Poisson solver.
C
      is=is+1
      js=js+1
      ks=ks+1

      do i=is,ie
         do j=js,je
            do k=ks,ke
               d(i,j,k)=d(i,j,k)/pig4
            enddo
         enddo
      enddo

*      PRINT*, 'Iterations: ',numItFine
*      PRINT*, 'Residual: ',resFine
*      PRINT*, 'Residual reduction: ',resRedFine
*      PRINT*, 'Status: ',istat
*      PRINT*, 'Time (s): ',time
c===================================================
c
c Copy the solution into the gp field array.  Note that the
c Z array's grid goes from is-1 to ie+1, etc.
c
c This is also wrong for more than one processor:
c

c       do l=1,N1LIM*N2LIM*N3LIM
c         k  = l / ( ( nx1z + 2 ) * ( nx2z + 2 ) ) + ks - 1
c         lp = l  - ( k - ( ks - 1 ) ) * ( nx1z + 2 ) * ( nx2z + 2 )
c         j  = lp / ( nx1z + 2 ) + js - 1
c         i  = lp - ( j - ( js - 1 ) ) * ( nx1z + 2 ) + is - 2
c         gp(i,j,k) = X( l )
c       enddo ! l

#endif /* GRAV */
CPS
#ifdef GRAV_FFT
C
C Poisson solver using FFTW library - by PSLi
C
      implicit NONE
#include "param.h"
#include "field.h"
#include "grid.h"
#include "gravity.h"
#include "mpicom.h"
#include "bndry.h"

      integer i,j,k,nx,ny,nz,iindex,jindex,kindex,snz,n
#ifdef MPI_USED
      INTEGER dest,status(MPI_STATUS_SIZE),source,maxn,maxnp1
#endif /* MPI_USED */
      double precision temp(maxn,maxn,maxn/nprocs_w),
     &     temp1(ie-is+1,je-js+1,(ke-ks+1)*nprocs_w),
     &     temp2(ie-is+1,je-js+1,ke-ks+1),h2,rtemp(ie*je),
     &     stemp(ie*je),dtemp(ie*je*ke)
      external poisson_solver_
      common /fftw/ maxn
C
C Initialize data
C
      nx=ie-is+1
      ny=je-js+1
      nz=ke-ks+1
      h2=(x1b(2)-x1b(1))**2*2.D0*pi*g
      maxnp1=maxn+1

      do i=is,ie
         iindex=i-is+1
         do j=js,je
            jindex=j-js+1
            do k=ks,ke
               kindex=k-ks+1
               IF(ntiles(1).GT.1)
     &              temp(abs(kindex-maxnp1),jindex,iindex)=d(i,j,k)*h2
               IF(ntiles(2).GT.1)
     &              temp(iindex,abs(kindex-maxnp1),jindex)=d(i,j,k)*h2
               IF(ntiles(3).GT.1)
     &              temp(iindex,jindex,kindex)=d(i,j,k)*h2
            enddo
         enddo
      enddo
C
C   Call the Poisson Solver subroutine
C
      IF(ntiles(1).GT.1)
     &     call poisson_solver(myid_w,nprocs_w,nz,ny,nx,temp)
      IF(ntiles(2).GT.1)
     &     call poisson_solver(myid_w,nprocs_w,nx,nz,ny,temp)
      IF(ntiles(3).GT.1)
     &     call poisson_solver(myid_w,nprocs_w,nx,ny,nz,temp)

      do i=is,ie
         iindex=i-is+1
         do j=js,je
            jindex=j-js+1
            do k=ks,ke
               kindex=k-ks+1
               IF(ntiles(1).GT.1)
     &              gp(i,j,k)=temp(abs(kindex-maxnp1),jindex,iindex)
               IF(ntiles(2).GT.1)
     &              gp(i,j,k)=temp(iindex,abs(kindex-maxnp1),jindex)
               IF(ntiles(3).GT.1)
     &              gp(i,j,k)=temp(iindex,jindex,kindex)
            enddo
         enddo
      enddo

#ifdef MPI_USED

      nreq=0
      nsub = nsub + 1
      call bvald(1,1,1,1,1,1,gp)
      
      if (nreq .ne. 0) call MPI_WAITALL ( nreq, req, stat, ierr )

#endif MPI_USED

C  Reset boundary flaps to zero.
      do i=1,6
         bvstat(i,1) = 0        !  d
      enddo

#endif /* GRAV_FFT */

#ifdef STONE_GRAV
c
c  PURPOSE: Controls the update of the gravitational self-potential
c  phi(i,j) found by solving the Poisson eqn.  Note that in ZEUS, phi is
c  defined to be a positive quantity.  This routine works for both
c  1- and 2-D problems.  In 1-D phi can be computed from a direct
c  integration of the Poisson eqn.  In 2-D a sparse matrix solver must
c  be used.  The only sparse matrix solvers implemented in this version
c  is ICCGAF - incomplete Cholesky decomposition/conjugate gradient.
c  Before a lengthy (and expensive) 2-D solution is begun, however, this
c  routine first checks the size of the relative error
c            errphi = [DEL**2(phi) -4*pi*G*rho]/4*pi*G*rho
c  and if it is less than graverr, the potential is not updated.
c
c  EXTERNALS: PHIBV, GICCG
c
c  LOCALS:
c-----------------------------------------------------------------------
      implicit NONE
#include "param.h"
#include "grid.h"
#include "field.h"
#include "root.h"
#include "scratch.h"
#include "gravity.h"
      integer  i,j,imax,imx,jmx,miticcg
      REAL     fpg,ephimx,qa,qb,qc,qd,qe,prdct,eiccg
c
      REAL  mass(in),acc(in),errphi(in)
      equivalence  (mass,wi0) , (acc,wi1) , (errphi,wi2)
c
      integer isamax
      external isamax,phibv,giccg
c=======================================================================
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\///////////////////////////////////
c--------------------------  1-D PROBLEM  ------------------------------
c
      if (nx2z .eq. 1) then
        fpg = 4.0*pi*g
        mass(is   ) = 0.0
        phi (is,js) = 0.0
        do 10 i=is+1,ie
          mass(i) = mass(i-1) + d(i-1,js)*(x1a(i)**3-x1a(i-1)**3)/3.0
          acc (i) = fpg*mass(i)/x1a(i)**2
          phi(i,js) = phi(i-1,js) - acc(i)*dx1b(i)
10      continue
        return
      endif
c
      if (nx1z .eq. 1) then
        return
      endif
c
c----------------------------  2-D PROBLEM  ----------------------------
c  First check if calculation of phi is needed this cycle. 
c
      ephimx = 0.0
      fpg    = 4.0*pi*g
      do 110 j=js,je
        qa = g32a(j+1)*dx2bi(j+1)
        qb = g32a(j  )*dx2bi(j  )
        do 100 i=ii(j),io(j)
          qc = g2b(i)*g2b(i)
          qd = g2a(i+1)*g31a(i+1)*dx1bi(i+1)
          qe = g2a(i  )*g31a(i  )*dx1bi(i  )
          prdct = (dvl1a(i)*dvl2a(j)*fpg*d(i,j)
     &     + qd*dvl2a(j)*phi(i+1,j) + qa*dvl1a(i)/qc*phi(i,j+1)
     &     + qe*dvl2a(j)*phi(i-1,j) + qb*dvl1a(i)/qc*phi(i,j-1))/
     &           ((qa+qb)*dvl1a(i)/qc + (qd+qe)*dvl2a(j))
          errphi(i) = abs(prdct - phi(i,j))/phi(i,j)
100     continue
        imax = isamax(nx1(j),errphi(ii(j)),1) + iim1(j)
        if (errphi(imax) .gt. ephimx) then
          ephimx = errphi(imax)
          imx = imax
          jmx = j
        endif
110   continue
      if (ephimx .le. graverr) return
      write(2,"(1x,'nhy=',i5,' GRAVITY: Solution of PE needed this ',
     & 'cycle, err =',1pe12.5,'at i,j=',2i3)") nhy,ephimx,imx,jmx
c
c  Recompute phi at this cycle
c
      eiccg   = epsgrv
      miticcg = maxgrv
      call phibv
      call giccg(eiccg,ks0grv,miticcg)
      if (miticcg .ge. maxgrv) then
        write(2,"(1x,'WARNING from GRAVITY: ICCGAF did not converge ',
     &  'within ',i3,' iterations')") miticcg
        nwarn = nwarn + 1
      else
        write(2,"(1x,'nhy=',i5,' GRAVITY: ICCG converged in ',i3,
     &  ' iterations, eps=',1pe12.5)") nhy,miticcg,eiccg
      endif
#endif /* STONE_GRAV */
      return
      end


