#include "zeusmp.def"

C CSR - 5/15/03 (based on AJY - 12/11/02)

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                F L O A T                  \\\\\\\\\\
c
c
c=======================================================================
c
       subroutine jet_bubble

       implicit NONE
#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#include "mpicom.h"

       integer i,j,k

       REAL r0,rho0,cs
       REAL rad, jet_rad, jet_d, jet_v

#ifdef PHYS_VISC
       REAL total_diss
       common/dissipation/total_diss
#endif /* PHYS_VISC */
            
c removed unused bndyall
       external      bndyflgs

       r0=1.0
       rho0=1.0
       cs=1.0

       jet_rad=0.025
       jet_d=0.01
       jet_v=105.5

#ifdef PHYS_VISC
       total_diss=0.0
#endif /* PHYS_VISC */

c       write (iotty, 2011)
c       write (iolog, 2011)
c2011   format('MYPROB  : Initialisation commencing')
       write(6,"(10x,'MYPROB  : Initialisation commencing')")
c
c
      do k=ks-2,ke+2
         do j=js-2,je+2
            do i=is-2,ie+2
c
c     set up undisturbed atmosphere
c
               rad=sqrt(x1b(i)**2.0+x2b(j)**2.0+x3b(k)**2.0)
               d(i,j,k)=rho0/((1.0+(rad/r0)**2.0)**0.75)
               e(i,j,k)=d(i,j,k)*cs**2.0/(gamma*(gamma-1.0))
               v1(i,j,k)=0.0
               v2(i,j,k)=0.0
               v3(i,j,k)=0.0
               gp(i,j,k)=cs**2.0*log(d(i,j,k))/gamma
            enddo
         enddo
      enddo
c
c     set up the jet
c
      if (x3b(ks) .lt. 0.1) then
         do j=js,je
            do i=is,ie
               rad=sqrt(x1b(i)**2.0+x2b(j)**2.0)
               if (rad .lt. jet_rad) then
                  v3ikb(i,j,1)=jet_v
                  v3ikb(i,j,2)=jet_v
                  dikb(i,j,1)=jet_d
                  dikb(i,j,2)=jet_d
                  nikb(i,j)=3
               endif
            enddo
         enddo
      endif
      call bndyflgs


c---All done

c       write (iotty, 2010)
c       write (iolog, 2010)
c2010   format('MYPROB  : Initialisation complete.')
c

       return
       end
