#include "zeusmp.def"

c JCV 10/27/03
c subroutine to update boundaries and turn jet off
c based on my subroutine from zeus3d
c JCV 4/29/04
c jet wiggle boundary update from Chris
c JCV 6/08/04
c try to addapt to my spherical geometry jets

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                 JET_WIGGLE                    \\\\\\\\\\
c
c=======================================================================
c

       subroutine jet_wiggle

       implicit NONE

#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#include "mpicom.h"

       integer i,j,k

       REAL offtime, vz, vxy, wiggle, omega

       integer thetamax

c removed unused bndyall
       external bndyflgs

ccccccccccccccccccccc

c
c     basic parameters of wiggle
c
       offtime=1.0
       wiggle=10.0*3.14159/180.0
       omega=0.1
c
c     impose wiggle
c
       if (time .lt. offtime) then
          do k=ks-2,ke+2
             do j=js-2,je+2
                v1iib(j,k,1)=v3ikb(i,j,1)*atan(wiggle)*sin(omega*time)
                v1iib(j,k,2)=v3ikb(i,j,2)*atan(wiggle)*sin(omega*time)
                v2iib(j,k,1)=v3ikb(i,j,1)*atan(wiggle)*cos(omega*time)
                v2iib(j,k,2)=v3ikb(i,j,2)*atan(wiggle)*cos(omega*time)
             enddo
          enddo
       endif
c
c     turn off jet
c
       if ((time .gt. offtime) .and. (time .lt. offtime+2.0*dt)) then
          do k=ks-2,ke+2
             do j=js-2,je+2
                write(6,"(/'Turning jets off')")
                v1iib(j,k,1)=0.0
                v1iib(j,k,2)=0.0
                v2iib(j,k,1)=0.0
                v2iib(j,k,2)=0.0
                v3iib(j,k,1)=0.0
                v3iib(j,k,2)=0.0
             enddo
          enddo
       endif

       return
       end
