#include "mgmpi.cpp"
#include "mgmpi.h"

C**************************************************************************
C**** THE FOLLOWING PARAMETERS MAY NEED TO BE CHANGED DEPENDING ON THE ****
C**** PROBLEM BEING SOLVED.  IN GENERAL, USE THE SMALLEST VALUES       ****
C**** POSSIBLE.                                                        ****   
C**************************************************************************

C     =================================================================
C     Arrary sizes
C     =================================================================

C     Maximum number of processors along each axis
      INTEGER PXLIM,PYLIM,PZLIM,PLIM

C     Maximum number of grid points along each axis per processor
      INTEGER NXLIM,NYLIM,NZLIM,NMAXLIM

C     Maximum number of multigrid levels used
      INTEGER MLIM


      PARAMETER (PXLIM=5,PYLIM=5,PZLIM=10,PLIM=PXLIM*PYLIM*PZLIM)
      PARAMETER (NXLIM=520,NYLIM=520,NZLIM=520,NMAXLIM=520)
      PARAMETER (MLIM = 5)

C      PARAMETER (NXLIM=66,NYLIM=66,NZLIM=66,NMAXLIM=66)
C      PARAMETER (NWLIM=2000000)
C      PARAMETER (MLIM = 4)

C***********************************************************************

C     -----------------------------------------------------------------
C     Direction labels (M='minus' direction ; P='plus' direction)
C     -----------------------------------------------------------------

      INTEGER XD,YD,ZD
      PARAMETER (XD = 1, YD = 2, ZD = 3)
      INTEGER XMD,YMD,ZMD,XPD,YPD,ZPD
      PARAMETER (XMD = 1, YMD = 2, ZMD = 3, XPD = 4, YPD = 5, ZPD = 6)

C     -----------------------------------------------------------------
C     Some constants
C     -----------------------------------------------------------------

      REAL mmSmall,mmSmall2,o1,o2,o4,o6,o8
      PARAMETER (mmSmall=1.0D-12)
      PARAMETER (mmSmall2=1.0D-24)
      PARAMETER (o1=1.0D0, o2=0.5D0, o4=0.25D0, o6=o1/6.0D0, o8=0.125D0)   
        
C     -----------------------------------------------------------------
C     Performance-related common blocks
C     -----------------------------------------------------------------

      INTEGER NTIMER
      PARAMETER (NTIMER = 300)

      DOUBLE PRECISION gtimestart(NTIMER),gtime(NTIMER)
      INTEGER gtimecount(NTIMER)
      CHARACTER*18 gtimename(NTIMER)
      REAL mmtarray(2)

      DOUBLE PRECISION gmflops(NTIMER)
      INTEGER icommtag
      DOUBLE PRECISION gcomm(NTIMER)

      COMMON /mmtime/ gtimestart,gtime,gtimecount,gtimename,mmtarray
      COMMON /mmflop/ gmflops
      COMMON /mmcomm/ gcomm,icommtag

C     -----------------------------------------------------------------
C     Global-flags common blocks (may be redundant with passed flags)
C     -----------------------------------------------------------------

      INTEGER giGridType, gbnd (3,MLIM), gbnd2(3)
      INTEGER gicoords,gisymmetric,gismoother,gimatfree
      INTEGER gsubcomm(0:1,0:1,0:1)  
      INTEGER gsubnbr(0:1,0:1,0:1,6)  
      INTEGER gmmgrid(MLIM),gmmcgrid(MLIM,0:PLIM-1)
      LOGICAL gmmIsCollapsed

C     (on = at grid points; off = halfway between gridpoints)

      REAL gdx(NXLIM,MLIM),gdy(NYLIM,MLIM),gdz(NZLIM,MLIM)
      REAL gdxi(NXLIM,MLIM),gdyi(NYLIM,MLIM),gdzi(NZLIM,MLIM)
      REAL gg2on(NXLIM,MLIM),gg31on(NXLIM,MLIM),gg32on(NYLIM,MLIM)
      REAL gg2off(NXLIM,MLIM),gg31off(NXLIM,MLIM),gg32off(NYLIM,MLIM)
      REAL gScaleA,gScaleB
      
      COMMON /mmInts/ giGridType,gbnd,gbnd2,gicoords,gisymmetric,
     &     gismoother,gimatfree,gsubcomm,gsubnbr,gmmgrid
      COMMON /mmReals/ gdx,gdy,gdz,gdxi,gdyi,gdzi,gScaleA,gScaleB,
     &     gg2on,gg31on,gg32on,gg2off,gg31off,gg32off
      COMMON /mmLogicals/ gmmIsCollapsed

C     -----------------------------------------------------------------
C     Parameters-to-COMMON blocks
C     -----------------------------------------------------------------

C     Processors
      INTEGER ip,ipx,ipy,ipz,npx,npy,npz,np
C     Semi-coarsening axes
      LOGICAL gmmlc1,gmmlc2,gmmlc3
C     Grid offsets  (gmmix(level,proc-offset))
      INTEGER gmmix(MLIM,0:PXLIM)
      INTEGER gmmiy(MLIM,0:PYLIM)
      INTEGER gmmiz(MLIM,0:PZLIM)
      COMMON /mmParams/ ip,ipx,ipy,ipz,npx,npy,npz,np,
     &               gmmix,gmmiy,gmmiz, 
     &               gmmlc1,gmmlc2,gmmlc3

      INTEGER gistorage
      COMMON /mmStorage/ gistorage

      INTEGER gFineSolver, gMaxItFine
      COMMON /mmSolver/ gFineSolver,gMaxItFine
