#include "zeusmp.def"
c=======================================================================
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
      subroutine msave(filename)
c
c  PURPOSE:  Writes [reads] all common block variables to the logical
c  unit 4.  Currently, the common blocks written [read] are:
c            common /gridvarr/ = real    grid     variables
c            common /gridvari/ = integer grid     variables
c            common /fieldr  / = real    field    variables
c            common /fieldi  / = integer field    variables
c            common /bndryr  / = real    boundary variables
c            common /bndryi  / = integer boundary variables
c            common /rootr   / = real    root     variables
c            common /rooti   / = integer root     variables
c            common /gravcomr/ = real    gravity  variables
c            common /gravcomi/ = integer gravity  variables
c
c  The following blocks are NOT written [read]:
c            common /frmlcomr/ = real    formal soln variables
c            common /frmlcomi/ = integer formal soln variables
c            common /mmntcomr/ = real    moment soln variables
c            common /mmntcomi/ = integer moment soln variables
c 
c  EXTERNALS: [none]
c
c  LOCALS:
c
c  MODIFIED: 26 Aug. 1996 by RAF for ZEUS-MP.
c  MODIFIED:  6 Jan. 1999 by JCH
c  MODIFIED:  7 Jan. 1999 by JCH (increased nrootr for root.h;
c                                 makes room for rad t-step var.)
c  MODIFIED: 18 May. 1999 by efh (increased nrootr due to tslice)
c-----------------------------------------------------------------------
      implicit NONE
#include "param.h"
      character*15 filename
c-------------------------
      integer ngridr,ngridi,mgridr
#include "grid.h"
#include "mpicom.h"
#ifdef MOVING_GRID
      parameter(mgridr = 40*in + 32*jn + 24*kn) 
#else
      parameter(mgridr = 0)
#endif
      parameter(ngridr  = 27*in + 21*jn + 15*kn + 3
     .         ,ngridi  = 13)
      REAL    rlgrdvr(ngridr + mgridr)
      integer ntgrdvr(ngridi)
      equivalence (rlgrdvr(1),x1a(1))
     . , (ntgrdvr(1),is)
c-------------------------
#include "field.h"
      integer nfield1,nfield2,nfield3,nfield4,nfieldr
      parameter(nfield1 = 5*in*jn*kn)
#ifdef MHD
      parameter(nfield2 = 3*in*jn*kn)
#else
      parameter(nfield2 = 0)
#endif
#if defined RAD || defined RAD_EXP
      parameter(nfield3=  in*jn*kn)
#else
      parameter(nfield3 = 0)
#endif
#if defined GRAV || defined GRAV_FFT
      parameter(nfield4 = in*jn*kn)
#else
      parameter(nfield4 = 0)
#endif /* GRAV || GRAV_FFT */
      parameter(nfieldr = nfield1 + nfield2 + nfield3
     &                  + nfield4)
      REAL    rlfldvr(nfieldr)
      equivalence (rlfldvr(1),d(1,1,1))
c-------------------------
#include "bndry.h"
      integer nbdryr,nbdryi,nbdry1,nbdry2,nbdry3,nbdry4,nbdry5,nbdry6
CJH   parameter(nbdry1  = 21*(jn*kn + in*kn + in*jn) 
      parameter(nbdry1  = 22*(jn*kn + in*kn + in*jn) 
     &                  +  6*nbvar)
      parameter(nbdry5  =  8*(jn*kn + in*kn + in*jn) 
     &                  +  6*nbvar  + 18)
#ifdef MHD
      parameter(nbdry2  = 24*(jn*kn + in*kn + in*jn) )
#else
      parameter(nbdry2  = 0)
#endif
CJH#ifdef RAD
#if defined RAD || defined RAD_EXP
      parameter(nbdry3  =  4*(jn*kn + in*kn + in*jn) )
      parameter(nbdry6  =  2*(jn*kn + in*kn + in*jn) )
#else
      parameter(nbdry3  = 0)
      parameter(nbdry6  = 0)
#endif
#if defined GRAV || defined GRAV_FFT
      parameter(nbdry4  =  4*(jn*kn + in*kn + in*jn) )
#else
      parameter(nbdry4  = 0)
#endif /* GRAV || GRAV_FFT */
      parameter(nbdryr  = nbdry1 + nbdry2 + nbdry3 + nbdry4
     &         ,nbdryi  = nbdry5 + nbdry6)
      REAL    rlbdryvr(nbdryr )
      integer ntbdryvr(nbdryi )
      equivalence (rlbdryvr(1),fiis(1)),(ntbdryvr(1),niis(1))
c-------------------------
#include "root.h"
      integer nrootr,nrooti,nrootch
#ifndef SHELLS
      parameter(nrootr = 49
     .        , nrooti = 37
     .        , nrootch= 4*15+8)
#else
      parameter(nrootr = 51 
     .        , nrooti = 38
     .        , nrootch= 5*15+8)
#endif /* NOT SHELLS */
      REAL    rlrtvr(nrootr)
      integer ntrtvr(nrooti)
      character*1 chrtvr(nrootch)
      equivalence (rlrtvr(1),b1floor) , (ntrtvr(1),ifsen(1))
     .          , (chrtvr(1),hdffile)
c  Well, this seems to equivalence all the filenames in the order
c  as defined in root.h to chrtvr. This is FORTRAN... (99/05/18)
c  So, the '+8' in nrootch is for tslfile.
c-------------------------
#include "gravity.h"
      integer ngravr,ngravi
CJH   parameter(ngravr = 9, ngravi = 7)
      parameter(ngravr = 10, ngravi = 17)
      REAL    rlgrvvr(ngravr)
      integer ntgrvvr(ngravi)
      equivalence (rlgrvvr(1),g)
     . , (ntgrvvr(1),m_grv)
c-------------------------
c\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\////////////////////////////////
c=======================================================================
c
      open(unit=4,file=filename,status='unknown',form='unformatted')
      write(4)  rl grd  vr , nt grd  vr
     &         ,rl fld  vr 
     &         ,rl bdry vr , nt bdry vr
     &         ,rl rt   vr , nt rt   vr , ch rt   vr
     &         ,rl grv  vr , nt grv  vr
      if (myid .eq. 0)
     &  write(2,"(/1x,'restart dump written at time=',1pe12.5,' cycle='
     & ,i6)") time,nhy
      close(unit=4)
      return
c
c-----------------------------  MGET  ----------------------------------
c
      entry mget(filename)
      open(unit=4,file=filename,status='old',form='unformatted')
      read(4)   rl grd  vr , nt grd  vr
     &         ,rl fld  vr
     &         ,rl bdry vr , nt bdry vr
     &         ,rl rt   vr , nt rt   vr , ch rt   vr
     &         ,rl grv  vr , nt grv  vr
      close(unit=4)
c
      return
      end
