#include "zeusmp.def"

C JCV 7/07/04 based partly on zeus3d msave
C a replacement for zeusmp's buggy msave/mget restart routines

      subroutine msave2(filename)
      implicit NONE
      character*15 filename
C include files
#include "param.h"
#include "field.h"
#include "root.h"
#include "mpicom.h"
#include "scratch.h"
#include "gravity.h"
#include "grid.h"
#include "bndry.h"
C open file to write to
      open(unit=4,file=filename,status='unknown',form='unformatted')
C write variables

C from field.h
      write(4)d,e,v1,v2,v3
#ifdef MHD
      write(4)b1,b2,b3
#endif /* MHD */
#if defined GRAV || GRAV_FFT
      write(4)gp
#endif /* GRAV || GRAV_FFT */

#if defined RAD || defined RAD_EXP
      write(4)er 
#endif

C from scratch
#if defined RAD_LOSS || defined T_CONDUCT
      write(4)cism,rcore,ncent,tmin
#endif /* RAD_LOSS || T_CONDUCT */

c These are variables for rgjet.F PROBLEM routine
      write(4)djet,v1jet,jetsize,efficiency,mcutoff
c These are variables for delayed.F BNDYUPDATE routine
      write(4)mdota,counter,counter2,tcounter,mjet
c These are variables for precess.F PROBLEM/BNDYUPDATE routine
      write(4)palpha,pomega

c      write(4)w1da,w1db,w1dc,w1dd,w1de,w1df
c     &,       w1dg,w1dh,w1di,w1dj,w1dk,w1dl,w1dm
c     &,       w1dn,w1do,w1dp,w1dq,w1dr,w1ds,w1dt
c     &,       w1du
c      write(4)w3da,w3db,w3dc,w3dd,w3de,w3df,w3dg
c     &,       w3di,w3dj

C from gravity.h
      write(4)g,tgrav,ptmass,x1ptm,x2ptm,x3ptm
      write(4)rt_fn_grv,rt_co_grv,wgt_grv
      write(4)mi_fn_grv,mi_co_grv,m_grv,nu_pr_grv,nu_po_grv
      write(4)vv_grv,sl_fn_grv,sl_co_grv,smth_grv
#ifdef SUP_GRAV
      write(4)gsup
#endif /* SUP_GRAV */

C from mpi_com
c      write(4)stat,req,periodic,reorder
c      write(4)myid, myid_w, nprocs, nprocs_w, coords
c      write(4)ierr, nreq, nsub,comm3d,ntiles,n1m,n1p,n2m,n2p,n3m,n3p
c      write(4)i_slice,j_slice,k_slice,ils_slice,jls_slice,kls_slice
c      write(4)ilsm_slice,jlsm_slice,klsm_slice,ibuf_in,ibuf_out
c      write(4)buf_in,buf_out

C from grid.h
      write(4)is,ie,js,je,ks,ke,ia,ja,ka,igcon
      write(4)nx1z,nx2z,nx3z
      write(4)x1a,x2a,x3a
     &     ,x1ai,x2ai,x3ai
     &     ,dx1a,dx2a,dx3a
     &     ,dx1ai,dx2ai,dx3ai
     &     ,vol1a,vol2a,vol3a
     &     ,dvl1a,dvl2a,dvl3a
     &     ,dvl1ai,dvl2ai,dvl3ai
      write(4)g2a,g31a,dg2ad1
     &     ,g2ai,g31ai,dg31ad1
      write(4)g32a,g32ai,dg32ad2
     &     ,g4a
      write(4)x1b,x2b,x3b
     &     ,x1bi,x2bi,x3bi
     &     ,dx1b,dx2b,dx3b
     &     ,dx1bi,dx2bi,dx3bi
     &     ,vol1b,vol2b,vol3b
     &     ,dvl1b,dvl2b,dvl3b
     &     ,dvl1bi,dvl2bi,dvl3bi
      write(4)g2b,g31b,dg2bd1 
     &     ,g2bi,g31bi,dg31bd1
      write(4)g32b,g32bi,dg32bd2
     &     ,g4b
      write(4)vg1,vg2,vg3,x1fac,x2fac,x3fac

C from bndry.h
      write(4)fiis,fois
     &      ,fijs,fojs
     &      ,fiks,foks
      write(4)niis,nois
     &      ,nijs,nojs
     &      ,niks,noks,bvstat

      write(4)niib,niib2,niib3,niib23
     &      ,noib,noib2,noib3,noib23
     &      ,nijb,nijb3,nijb1,nijb31
     &      ,nojb,nojb3,nojb1,nojb31
     &      ,nikb,nikb1,nikb2,nikb12
     &      ,nokb,nokb1,nokb2,nokb12

#if defined RAD || defined RAD_EXP
      write(4)liib,loib
     &      ,lijb,lojb
     &      ,likb,lokb
#endif /* RAD || RAD_EXP */

      write(4)diib,doib
     &     ,dijb,dojb
     &     ,dikb,dokb
      write(4)eiib,eoib
     &     ,eijb,eojb
     &     ,eikb,eokb
      write(4)v1iib,v1oib
     &     ,v1ijb,v1ojb
     &     ,v1ikb,v1okb
      write(4)v2iib,v2oib
     &     ,v2ijb,v2ojb
     &     ,v2ikb,v2okb
      write(4)v3iib,v3oib
     &     ,v3ijb,v3ojb
     &     ,v3ikb,v3okb
#ifdef MHD
      write(4)b1iib,b1oib
     &     ,b1ijb,b1ojb
     &     ,b1ikb,b1okb
      write(4)b2iib,b2oib
     &     ,b2ijb,b2ojb
     &     ,b2ikb,b2okb
      write(4)b3iib,b3oib
     &     ,b3ijb,b3ojb
     &     ,b3ikb,b3okb
      write(4)emf1iib,emf1oib 
     &     ,emf1ijb,emf1ojb 
     &     ,emf1ikb,emf1okb
      write(4)emf2iib,emf2oib 
     &     ,emf2ijb,emf2ojb 
     &     ,emf2ikb,emf2okb
      write(4)emf3iib,emf3oib 
     &     ,emf3ijb,emf3ojb 
     &     ,emf3ikb,emf3okb
#endif /* MHD */

#if defined RAD || defined RAD_EXP
      write(4)eriib,eroib
     &     , erijb,erojb
     &     , erikb,erokb
#endif /* RAD || RAD_EXP */

#if defined GRAV || defined GRAV_FFT
      write(4)gpiib,gpoib
     &     ,gpijb,gpojb
     &     ,gpikb,gpokb
#endif /* GRAV || GRAV_FFT */

C from root.h
      write(4)
     & b1floor   ,b2floor   ,b3floor   ,ciso      
     &,courno    ,dfloor
     &,dtal    ,dtcs    ,dtv1    ,dtv2    ,dtv3
     &,dtqq    ,dtnew
#ifdef SUB_AV
     &,avisc_dt
#endif
     &,dtrd
     &,dt        ,dtdump 
     &,dthdf     ,dthist    ,dtmin     ,dttsl
     &,dtqqi2    ,dtnri2    ,dtrdi2    ,dtimrdi2
     &,dtusr
     &,efloor    ,erfloor   ,gamma     ,gamm1
     &,qcon      ,qlin 
     &,tdump
     &,thdf      ,thist     ,time      ,tlim      ,cpulim
     &,trem      ,tsave     ,ttsl
     &,tused     ,tusr
#ifdef SHELLS
     &,tshl, dtshl
#endif /* SHELLS */
     &,v1floor   ,v2floor   ,v3floor 
     &,emf1floor ,emf2floor ,emf3floor 
     &,gpfloor

      write(4)
     & ifsen
     &,idebug
     &,iordb1    ,iordb2    ,iordb3    ,iordd
     &,iorde     ,iorder    ,iords1    ,iords2
     &,iords3
     &,istpb1    ,istpb2    ,istpb3    ,istpd     ,istpe     ,istper
     &,istps1    ,istps2    ,istps3
     &,ix1x2x3   ,jx1x2x3
     &,nhy       ,nlim      ,nred      ,mbatch
     &,nwarn     ,nseq      ,flstat
     &,ioinp     ,iotsl     ,iolog     ,iohst     ,iomov     ,iores
     &,ioshl

      write(4)id,hdffile,hstfile,resfile,usrfile
#ifdef SHELLS
     &,shlfile
#endif /* SHELLS */
     &,tslfile

C write notification in log
#ifdef MPI_USED
      if(myid .eq. 0)then
#endif /* MPI_USED */
      write(2,"(/1x,'restart dump written at time=',1pe12.5,'cycle='
     &,i6)")time,nhy
#ifdef MPI_USED
      endif
#endif /* MPI_USED */

C close file
      close(unit=4)

      return
      end
