#include "zeusmp.def"

C JCV 6/04/04 SEDNOV Blast wave tube test

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                  SEDBLAST                    \\\\\\\\\\
c
c=======================================================================
c
       subroutine sedblast

       implicit NONE
#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#include "mpicom.h"

      integer i,j,k
      REAL dback,P,eblast,rblast
      REAL radius

      dback=1
      P=0.00001
      eblast=50
      rblast=0.2
#ifndef XYZ
      do k=ks,ke
         do j=js,je
            do i=is,ie
               d(i,j,k)=dback
               e(i,j,k)=P/(gamma-1)
               v1(i,j,k)=0.0
               v2(i,j,k)=0.0
               v3(i,j,k)=0.0
               if (x1a(i) .lt. rblast) then
                  e(i,j,k)=eblast
               endif
            enddo
         enddo
      enddo
#endif /*!XYZ!*/

#ifdef XYZ
      do k=ks,ke
         do j=js,je
            do i=is,ie
               d(i,j,k)=dback
               e(i,j,k)=P/(gamma-1)
               v1(i,j,k)=0.0
               v2(i,j,k)=0.0
               v3(i,j,k)=0.0
               radius=(x1a(i)**2)+(x2a(j)**2)+(x3a(k)**2)
               if(radius .lt. rblast) then
                  e(i,j,k)=eblast
               endif
            enddo
         enddo
      enddo
#endif /*XYZ*/

      call bndyflgs

      return
      end
