#include "zeusmp.def"
c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////               S P E N E R G Y             \\\\\\\\\\
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
c=======================================================================
c
       subroutine spenergy
#ifndef ISO
     &                (ibeg,iend,jbeg,jend,kbeg,kend,eod)
c
c Computes the specific internal energy density eod for the transport
c step.
c 
c
c Written by RAF 2/12/96.
c Modified   efh 99/05/14 for use in zeusmp
c......................................................................
       implicit NONE
#include "param.h"
#include "root.h"
#include "grid.h"
#include "field.h"
#ifdef MPI_USED
#include "mpicom.h"
#endif /* MPI_USED */

       integer i,j,k,ibeg,iend,jbeg,jend,kbeg,kend
       REAL eod(in,jn,kn)

#ifndef UNROLL_I
#define UNROLL_I
#endif

#ifdef DBGZMP_SPENERGY
       write(*,"('SPENERGY: Process ',i2,' entering')")
     &           myid
         call flush(flstat, 101)
#endif /* DBGZMP_SPENERGY */

       do k=kbeg,kend
         do j=jbeg,jend
CDIR$ UNROLL (UNROLL_I)
           do i=ibeg,iend
#ifdef DBGZMP_SPENERGY
             if (idebug .gt. 15) then
               if (d(i,j,k) .eq. 0.0) then
                 write(*,"('SPENERGY: Process ',i2,': WARNING : ',
     &                'd=0.0 at i=',i3,' j=',i3,' k=',i3)")
     &                myid, i,j,k
               endif
             endif
#endif  /* DBGZMP_SPENERGY */

#ifndef TOTAL_ENERGY
             eod(i,j,k) = e(i,j,k) / d(i,j,k)
#else /* not TOTAL_ENERGY */
             eod(i,j,k) = gamma * e(i,j,k) / d(i,j,k)
     1                  - gamm1 * ( ( v1(i,j,k) + v1(i+1,j  ,k  ) )**2
     2                            + ( v2(i,j,k) + v2(i  ,j+1,k  ) )**2
     3                            + ( v3(i,j,k) + v3(i  ,j  ,k+1) )**2 )
     4                          * 0.125
#ifdef GRAV
     5                  - gamm1 * gp(i,j,k)
#endif /* GRAV */
#endif /* not TOTAL_ENERGY */
           enddo
         enddo
       enddo
c
#endif /* not ISO */

#ifdef DBGZMP_SPENERGY
       write(*,"('SPENERGY: Process ',i2,' finished')")
     &           myid
         call flush(flstat, 101)
#endif /* DBGZMP_SPENERGY */


       return
       end


