#include "zeusmp.def"
c
c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////               U P E D G E S               \\\\\\\\\\
c
c                            Developed by
c                Laboratory of Computational Astrophysics
c               University of Illinois at Urbana-Champaign
c
c=======================================================================
c
       subroutine upedges
c
CPS
c
       implicit NONE
#include "param.h"
#include "root.h"
#include "field.h"
#include "grid.h"
#include "bndry.h"
c
       integer i,j,k
c
c-----------------------------------------------------------------------
c----------------------------  K - E D G E S  --------------------------
c-----------------------------------------------------------------------
c
c
c      Inner j k-edges.
c
       DO k=ks-2,ke+2

          if (nijb(is-1,k) .eq. 1) then
             d(is-1,js-1,k) = d(is-1,js  ,k)
             d(is-1,js-2,k) = d(is-1,js+1,k)
             dijb(is-1,k,3) = d(is-1,js+2,k)
             d(is-2,js-1,k) = d(is-2,js  ,k)
             d(is-2,js-2,k) = d(is-2,js+1,k)
             dijb(is-2,k,3) = d(is-2,js+2,k)
          endif

          if (nijb(ie+1,k) .eq. 1) then
             d(ie+1,js-1,k) = d(ie+1,js  ,k)
             d(ie+1,js-2,k) = d(ie+1,js+1,k)
             dijb(ie+1,k,3) = d(ie+1,js+2,k)
             d(ie+2,js-1,k) = d(ie+2,js  ,k)
             d(ie+2,js-2,k) = d(ie+2,js+1,k)
             dijb(ie+2,k,3) = d(ie+2,js+2,k)
          endif

          if (nijb(is-1,k) .eq. 2) then
             d(is-1,js-1,k) = d(is-1,js  ,k)
             d(is-1,js-2,k) = d(is-1,js-1,k)
             dijb(is-1,k,3) = d(is-1,js-2,k)
             d(is-2,js-1,k) = d(is-2,js  ,k)
             d(is-2,js-2,k) = d(is-2,js-1,k)
             dijb(is-2,k,3) = d(is-2,js-2,k)
          endif

          if (nijb(ie+1,k) .eq. 2) then
             d(ie+1,js-1,k) = d(ie+1,js  ,k)
             d(ie+1,js-2,k) = d(ie+1,js-1,k)
             dijb(ie+1,k,3) = d(ie+1,js-2,k)
             d(ie+2,js-1,k) = d(ie+2,js  ,k)
             d(ie+2,js-2,k) = d(ie+2,js-1,k)
             dijb(ie+2,k,3) = d(ie+2,js-2,k)
          endif

          if (nijb(is-1,k) .eq. 3) then
             d(is-1,js-1,k) = dijb(is-1,k,1)
             d(is-1,js-2,k) = dijb(is-1,k,2)
c            do nothing for dijb(is-1,k,3)
             d(is-2,js-1,k) = dijb(is-2,k,1)
             d(is-2,js-2,k) = dijb(is-2,k,2)
c            do nothing for dijb(is-2,k,3)
          endif

          if (nijb(ie+1,k) .eq. 3) then
             d(ie+1,js-1,k) = dijb(ie+1,k,1)
             d(ie+1,js-2,k) = dijb(ie+1,k,2)
c            do nothing for dijb(ie+1,k,3)
             d(ie+2,js-1,k) = dijb(ie+2,k,1)
             d(ie+2,js-2,k) = dijb(ie+2,k,2)
c            do nothing for dijb(ie+2,k,3)
          endif

          if (nijb(is-1,k) .eq. 4) then
             d(is-1,js-1,k) = d(is-1,je  ,k)
             d(is-1,js-2,k) = d(is-1,je-1,k)
             dijb(is-1,k,3) = d(is-1,je-2,k)
             d(is-2,js-1,k) = d(is-2,je  ,k)
             d(is-2,js-2,k) = d(is-2,je-1,k)
             dijb(is-2,k,3) = d(is-2,je-2,k)
          endif

          if (nijb(ie+1,k) .eq. 4) then
             d(ie+1,js-1,k) = d(ie+1,je  ,k)
             d(ie+1,js-2,k) = d(ie+1,je-1,k)
             dijb(ie+1,k,3) = d(ie+1,je-2,k)
             d(ie+2,js-1,k) = d(ie+2,je  ,k)
             d(ie+2,js-2,k) = d(ie+2,je-1,k)
             dijb(ie+2,k,3) = d(ie+2,je-2,k)
          endif

          if (nijb(is-1,k) .eq. 5) then
             d(is-1,js-1,k) = d(is-1,js  ,k)
             d(is-1,js-2,k) = d(is-1,js+1,k)
             dijb(is-1,k,3) = d(is-1,js+2,k)
             d(is-2,js-1,k) = d(is-2,js  ,k)
             d(is-2,js-2,k) = d(is-2,js+1,k)
             dijb(is-2,k,3) = d(is-2,js+2,k)
          endif

          if (nijb(ie+1,k) .eq. 5) then
             d(ie+1,js-1,k) = d(ie+1,js  ,k)
             d(ie+1,js-2,k) = d(ie+1,js+1,k)
             dijb(ie+1,k,3) = d(ie+1,js+2,k)
             d(ie+2,js-1,k) = d(ie+2,js  ,k)
             d(ie+2,js-2,k) = d(ie+2,js+1,k)
             dijb(ie+2,k,3) = d(ie+2,js+2,k)
          endif

       ENDDO
c
c
c      Outer j k-edges.
c
       DO k=ks-2,ke+2

          if (nojb(is-1,k) .eq. 1) then
             d(is-1,je+1,k) = d(is-1,je  ,k)
             d(is-1,je+2,k) = d(is-1,je-1,k)
             d(is-2,je+1,k) = d(is-2,je  ,k)
             d(is-2,je+2,k) = d(is-2,je-1,k)
          endif

          if (nojb(ie+1,k) .eq. 1) then
             d(ie+1,je+1,k) = d(ie+1,je  ,k)
             d(ie+1,je+2,k) = d(ie+1,je-1,k)
             d(ie+2,je+1,k) = d(ie+2,je  ,k)
             d(ie+2,je+2,k) = d(ie+2,je-1,k)
          endif

          if (nojb(is-1,k) .eq. 2) then
             d(is-1,je+1,k) = d(is-1,je,k)
             d(is-1,je+2,k) = d(is-1,je+1,k)
             d(is-2,je+1,k) = d(is-2,je,k)
             d(is-2,je+2,k) = d(is-2,je+1,k)
          endif

          if (nojb(ie+1,k) .eq. 2) then
             d(ie+1,je+1,k) = d(ie+1,je,k)
             d(ie+1,je+2,k) = d(ie+1,je+1,k)
             d(ie+2,je+1,k) = d(ie+2,je,k)
             d(ie+2,je+2,k) = d(ie+2,je+1,k)
          endif

          if (nojb(is-1,k) .eq. 3) then
             d(is-1,je+1,k) = dojb(is-1,k,1)
             d(is-1,je+2,k) = dojb(is-1,k,2)
             d(is-2,je+1,k) = dojb(is-2,k,1)
             d(is-2,je+2,k) = dojb(is-2,k,2)
          endif

          if (nojb(ie+1,k) .eq. 3) then
             d(ie+1,je+1,k) = dojb(ie+1,k,1)
             d(ie+1,je+2,k) = dojb(ie+1,k,2)
             d(ie+2,je+1,k) = dojb(ie+2,k,1)
             d(ie+2,je+2,k) = dojb(ie+2,k,2)
          endif

          if (nojb(is-1,k) .eq. 4) then
             d(is-1,je+1,k) = d(is-1,js  ,k)
             d(is-1,je+2,k) = d(is-1,js+1,k)
             d(is-2,je+1,k) = d(is-2,js  ,k)
             d(is-2,je+2,k) = d(is-2,js+1,k)
          endif

          if (nojb(ie+1,k) .eq. 4) then
             d(ie+1,je+1,k) = d(ie+1,js  ,k)
             d(ie+1,je+2,k) = d(ie+1,js+1,k)
             d(ie+2,je+1,k) = d(ie+2,js  ,k)
             d(ie+2,je+2,k) = d(ie+2,js+1,k)
          endif

          if (nojb(is-1,k) .eq. 5) then
             d(is-1,je+1,k) = d(is-1,je  ,k)
             d(is-1,je+2,k) = d(is-1,je-1,k)
             d(is-2,je+1,k) = d(is-2,je  ,k)
             d(is-2,je+2,k) = d(is-2,je-1,k)
          endif

          if (nojb(ie+1,k) .eq. 5) then
             d(ie+1,je+1,k) = d(ie+1,je  ,k)
             d(ie+1,je+2,k) = d(ie+1,je-1,k)
             d(ie+2,je+1,k) = d(ie+2,je  ,k)
             d(ie+2,je+2,k) = d(ie+2,je-1,k)
          endif

       ENDDO
c
c
c
c      Inner i k-edges.
c
       DO k=ks-2,ke+2

          if (nijb(js-1,k) .eq. 1) then
             d(is-1,js-1,k) = d(is  ,js-1,k)
             d(is-2,js-1,k) = d(is+1,js-1,k)
             dijb(k,js-1,3) = d(is+2,js-1,k)
             d(is-1,js-2,k) = d(is  ,js-2,k)
             d(is-2,js-2,k) = d(is+1,js-2,k)
             dijb(k,js-2,3) = d(is+2,js-2,k)
          endif

          if (nijb(je+1,k) .eq. 1) then
             d(is-1,je+1,k) = d(is  ,je+1,k)
             d(is-2,je+1,k) = d(is+1,je+1,k)
             dijb(k,je+1,3) = d(is+2,je+1,k)
             d(is-1,je+2,k) = d(is  ,je+2,k)
             d(is-2,je+2,k) = d(is+1,je+2,k)
             dijb(k,je+2,3) = d(is+2,je+2,k)
          endif

          if (nijb(js-1,k) .eq. 2) then
             d(is-1,js-1,k) = d(is  ,js-1,k)
             d(is-2,js-1,k) = d(is-1,js-1,k)
             dijb(k,js-1,3) = d(is-2,js-1,k)
             d(is-1,js-2,k) = d(is  ,js-2,k)
             d(is-2,js-2,k) = d(is-1,js-2,k)
             dijb(k,js-2,3) = d(is-2,js-2,k)
          endif

          if (nijb(je+1,k) .eq. 2) then
             d(is-1,je+1,k) = d(is,  je+1,k)
             d(is-2,je+1,k) = d(is-1,je+1,k)
             dijb(k,je+1,3) = d(is-2,je+1,k)
             d(is-1,je+2,k) = d(is  ,je+2,k)
             d(is-2,je+2,k) = d(is-1,je+2,k)
             dijb(k,je+2,3) = d(is-2,je+2,k)
          endif

          if (nijb(js-1,k) .eq. 3) then
             d(is-1,js-1,k) = dijb(k,js-1,1)
             d(is-2,js-1,k) = dijb(k,js-1,2)
c            do nothing for dijb(k,js-1,3)
             d(is-1,js-2,k) = dijb(k,js-2,1)
             d(is-2,js-2,k) = dijb(k,js-2,2)
c            do nothing for dijb(k,js-2,3)
          endif

          if (nijb(ie+1,k) .eq. 3) then
             d(is-1,je+1,k) = dijb(k,je+1,1)
             d(is-2,je+1,k) = dijb(k,je+1,2)
c            do nothing for dijb(k,je+1,3)
             d(is-1,je+2,k) = dijb(k,je+2,1)
             d(is-2,je+2,k) = dijb(k,je+2,2)
c            do nothing for dijb(k,je+2,3)
          endif

          if (nijb(js-1,k) .eq. 4) then
             d(is-1,js-1,k) = d(ie  ,js-1,k)
             d(is-2,js-1,k) = d(ie-1,js-1,k)
             dijb(k,js-1,3) = d(ie-2,js-1,k)
             d(is-1,js-2,k) = d(ie  ,js-2  ,k)
             d(is-2,js-2,k) = d(ie-1,js-2,k)
             dijb(k,js-2,3) = d(ie-2,js-2,k)
          endif

          if (nijb(ie+1,k) .eq. 4) then
             d(ie+1,js-1,k) = d(ie+1,je  ,k)
             d(ie+1,js-2,k) = d(ie+1,je-1,k)
             dijb(ie+1,k,3) = d(ie+1,je-2,k)
             d(ie+2,js-1,k) = d(ie+2,je  ,k)
             d(ie+2,js-2,k) = d(ie+2,je-1,k)
             dijb(ie+2,k,3) = d(ie+2,je-2,k)
          endif

          if (nijb(is-1,k) .eq. 5) then
             d(is-1,js-1,k) = d(is-1,js  ,k)
             d(is-1,js-2,k) = d(is-1,js+1,k)
             dijb(is-1,k,3) = d(is-1,js+2,k)
             d(is-2,js-1,k) = d(is-2,js  ,k)
             d(is-2,js-2,k) = d(is-2,js+1,k)
             dijb(is-2,k,3) = d(is-2,js+2,k)
          endif

          if (nijb(ie+1,k) .eq. 5) then
             d(ie+1,js-1,k) = d(ie+1,js  ,k)
             d(ie+1,js-2,k) = d(ie+1,js+1,k)
             dijb(ie+1,k,3) = d(ie+1,js+2,k)
             d(ie+2,js-1,k) = d(ie+2,js  ,k)
             d(ie+2,js-2,k) = d(ie+2,js+1,k)
             dijb(ie+2,k,3) = d(ie+2,js+2,k)
          endif

       ENDDO
c
c
c      Outer j k-edges.
c
       DO k=ks-2,ke+2

          if (nojb(is-1,k) .eq. 1) then
             d(is-1,je+1,k) = d(is-1,je  ,k)
             d(is-1,je+2,k) = d(is-1,je-1,k)
             d(is-2,je+1,k) = d(is-2,je  ,k)
             d(is-2,je+2,k) = d(is-2,je-1,k)
          endif

          if (nojb(ie+1,k) .eq. 1) then
             d(ie+1,je+1,k) = d(ie+1,je  ,k)
             d(ie+1,je+2,k) = d(ie+1,je-1,k)
             d(ie+2,je+1,k) = d(ie+2,je  ,k)
             d(ie+2,je+2,k) = d(ie+2,je-1,k)
          endif

          if (nojb(is-1,k) .eq. 2) then
             d(is-1,je+1,k) = d(is-1,je,k)
             d(is-1,je+2,k) = d(is-1,je+1,k)
             d(is-2,je+1,k) = d(is-2,je,k)
             d(is-2,je+2,k) = d(is-2,je+1,k)
          endif

          if (nojb(ie+1,k) .eq. 2) then
             d(ie+1,je+1,k) = d(ie+1,je,k)
             d(ie+1,je+2,k) = d(ie+1,je+1,k)
             d(ie+2,je+1,k) = d(ie+2,je,k)
             d(ie+2,je+2,k) = d(ie+2,je+1,k)
          endif

          if (nojb(is-1,k) .eq. 3) then
             d(is-1,je+1,k) = dojb(is-1,k,1)
             d(is-1,je+2,k) = dojb(is-1,k,2)
             d(is-2,je+1,k) = dojb(is-2,k,1)
             d(is-2,je+2,k) = dojb(is-2,k,2)
          endif

          if (nojb(ie+1,k) .eq. 3) then
             d(ie+1,je+1,k) = dojb(ie+1,k,1)
             d(ie+1,je+2,k) = dojb(ie+1,k,2)
             d(ie+2,je+1,k) = dojb(ie+2,k,1)
             d(ie+2,je+2,k) = dojb(ie+2,k,2)
          endif

          if (nojb(is-1,k) .eq. 4) then
             d(is-1,je+1,k) = d(is-1,js  ,k)
             d(is-1,je+2,k) = d(is-1,js+1,k)
             d(is-2,je+1,k) = d(is-2,js  ,k)
             d(is-2,je+2,k) = d(is-2,js+1,k)
          endif

          if (nojb(ie+1,k) .eq. 4) then
             d(ie+1,je+1,k) = d(ie+1,js  ,k)
             d(ie+1,je+2,k) = d(ie+1,js+1,k)
             d(ie+2,je+1,k) = d(ie+2,js  ,k)
             d(ie+2,je+2,k) = d(ie+2,js+1,k)
          endif

          if (nojb(is-1,k) .eq. 5) then
             d(is-1,je+1,k) = d(is-1,je  ,k)
             d(is-1,je+2,k) = d(is-1,je-1,k)
             d(is-2,je+1,k) = d(is-2,je  ,k)
             d(is-2,je+2,k) = d(is-2,je-1,k)
          endif

          if (nojb(ie+1,k) .eq. 5) then
             d(ie+1,je+1,k) = d(ie+1,je  ,k)
             d(ie+1,je+2,k) = d(ie+1,je-1,k)
             d(ie+2,je+1,k) = d(ie+2,je  ,k)
             d(ie+2,je+2,k) = d(ie+2,je-1,k)
          endif

       ENDDO
c
       return
       end
