#include "zeusmp.def"

c JCV 05/26/05
c subroutine to check for NaNs
c DO NOT use in production runs


c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                 NANTEST                   \\\\\\\\\\
c
c=======================================================================
c

       subroutine nantest

       implicit NONE

#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
c Code to check for NaNs in energy
c DO NOT use in real runs.
c DOES NOT work with intel compiler in almost all cases
c does with with gcc
c jcv 6/01/2005

#include "root.h"
#include "scratch.h"
#include "mpicom.h"

       integer i,j,k
       integer test
       
       character*15 filename
       write(filename,"(a4,3i2.2,'.','hdf')") 'last',coords(1)
     &      ,coords(2),coords(3)


       write(*,*)'Check for NaN, disable in production runs'

       test=0
       do k=ks-2,ke+2
          do j=js-2,je+2
             do i=is-2,ie+2
                if(e(i,j,k).ne.e(i,j,k))then
c                   write(*,*)'Nan in e at ',i,j,k,' processor= ',myid
                   test=1
c                   call MPI_FINALIZE
c                   stop
                endif
                if(d(i,j,k).ne.d(i,j,k))then
                   test=1
                endif
             enddo
          enddo
       enddo

       if(test.eq.1)then
          call hdfall(filename)
          call MPI_FINALIZE
          stop
       endif

       return
       end

c This is extra test code taken from tconduct.F, but could be used
c elsewhere

c      write(filename,"(a4,e7.1)")'test',time
c      test=hdfwrite(olde,filename)
c      write(*,*)'wrote hdf at time=',time,' filename = ',filename


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c$$$
c$$$      integer function hdfwrite(hwrite,filename)
c$$$
c$$$#include "param.h"
c$$$#include "grid.h"
c$$$#include "root.h"
c$$$      
c$$$      REAL hwrite(in,jn,kn)
c$$$
c$$$      character*15 filename
c$$$      character*16 coordsys
c$$$      character*32 string
c$$$      integer  i,j,k,indx
c$$$      integer rank,shape(3),ret
c$$$      real data(in*jn*kn),xscale(in),yscale(jn),zscale(kn)
c$$$      integer  dssdims,dssdast,dssdisc,dsadata,dspdata
c$$$
c$$$      external dssdims,dssdast,dssdisc,dsadata,dspdata
c$$$#ifdef RTP
c$$$      coordsys = 'spherical polar' // char(0)
c$$$#endif
c$$$#ifdef ZRP
c$$$      coordsys = 'cylindrical' // char(0)
c$$$#endif
c$$$#ifdef XYZ
c$$$      coordsys = 'cartesian' // char(0)
c$$$#endif
c$$$
c$$$c      write(filename,"(a4,f5.3,'.hdf')")'test',time
c$$$c      filename="test.hdf"
c$$$      do 10 i=is,ie
c$$$        xscale(i-is+1) = real(x1b(i))
c$$$ 10         continue
c$$$      do 20 j=js,je
c$$$        yscale(j-js+1) = real(x2b(j))
c$$$ 20         continue
c$$$      do 30 k=ks,ke
c$$$        zscale(k-ks+1) = real(x3b(k))
c$$$ 30         continue
c$$$
c$$$      rank     = 3
c$$$      shape(1) = nx1z
c$$$      shape(2) = nx2z
c$$$      shape(3) = nx3z
c$$$      ret = dssdims(rank,shape)
c$$$      ret = dssdisc(1,shape(1),xscale)
c$$$      ret = dssdisc(2,shape(2),yscale)
c$$$      ret = dssdisc(3,shape(3),zscale)
c$$$
c$$$
c$$$
c$$$      do 120 k=ks,ke
c$$$        do 110 j=js,je
c$$$          do 100 i=is,ie
c$$$            indx = (k-ks)*nx2z*nx1z + (j-js)*nx1z + (i-is) + 1
c$$$c            data(indx) = real(0.5*(hwrite(i,j,k) + hwrite(i+1,j,k)))
c$$$            data(indx)=real(hwrite(i,j,k))
c$$$ 100               continue
c$$$ 110                    continue
c$$$ 120                       continue
c$$$      write(string,"('data AT TIME=',1pe8.2,'     ')") time
c$$$      ret = dssdast(string,' ',' ',coordsys)
c$$$      ret = dspdata(filename,rank,shape,data)
c$$$
c$$$      hdfwrite=1
c$$$      return
c$$$      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
